package com.eco.plugin.xx.zgydsso.config;

import com.fr.config.*;
import com.fr.config.holder.Conf;
import com.fr.config.holder.factory.Holders;
import com.fr.intelli.record.Focus;
import com.fr.intelli.record.Original;
import com.fr.record.analyzer.EnableMetrics;

@Visualization(category = "认证集成配置")
@EnableMetrics
public class PluginSimpleConfig extends DefaultConfiguration {

    private static volatile PluginSimpleConfig config = null;

    @Focus(id="com.eco.plugin.xx.zgydsso.config", text = "认证集成配置", source = Original.PLUGIN)
    public static PluginSimpleConfig getInstance() {
        if (config == null) {
            config = ConfigContext.getConfigInstance(PluginSimpleConfig.class);
        }
        return config;
    }

    @Identifier(value = "configurl", name = "properties配置文件路径", description = "配置文件路径", status = Status.SHOW)
    private Conf<String> configurl = Holders.simple("");

    @Identifier(value = "configurlxml", name = "xml配置文件路径", description = "xml配置文件路径", status = Status.SHOW)
    private Conf<String> configurlxml = Holders.simple("");

    @Identifier(value = "dataurl", name = "同步文件路径", description = "同步文件路径", status = Status.SHOW)
    private Conf<String> dataurl = Holders.simple("");

    @Identifier(value = "usernamefile", name = "工号文件前缀", description = "工号文件前缀", status = Status.SHOW)
    private Conf<String> usernamefile = Holders.simple("");

    @Identifier(value = "rolelinkfile", name = "工号角色关系文件前缀", description = "工号角色关系文件前缀", status = Status.SHOW)
    private Conf<String> rolelinkfile = Holders.simple("");

    @Identifier(value = "needToken", name = "是否需要拼接token", description = "是否需要拼接token", status = Status.SHOW)
    private Conf<Boolean> needToken = Holders.simple(false);

    public String getConfigurl() {
        return configurl.get();
    }

    public void setConfigurl(String url) {
        this.configurl.set(url);
    }

    public String getConfigurlxml() {
        return configurlxml.get();
    }

    public void setConfigurlxml(String url) {
        this.configurlxml.set(url);
    }

    public String getDataurl() {
        return dataurl.get();
    }

    public void setDataurl(String url) {
        this.dataurl.set(url);
    }

    public String getUsernamefile() {
        return usernamefile.get();
    }

    public void setUsernamefile(String url) {
        this.usernamefile.set(url);
    }

    public String getRolelinkfile() {
        return rolelinkfile.get();
    }

    public void setRolelinkfile(String url) {
        this.rolelinkfile.set(url);
    }

    public Boolean getNeedToken() {
        return needToken.get();
    }

    public void setNeedToken(Boolean url) {
        this.needToken.set(url);
    }

    @Override
    public Object clone() throws CloneNotSupportedException {
        PluginSimpleConfig cloned = (PluginSimpleConfig) super.clone();
//        cloned.text = (Conf<String>) text.clone();
//        cloned.count = (Conf<Integer>) count.clone();
//        cloned.price = (Conf<Double>) price.clone();
//        cloned.time = (Conf<Long>) time.clone();
//        cloned.student = (Conf<Boolean>) student.clone();
        return cloned;
    }

}
