package com.eco.plugin.xx.zgydsso.filter;

import com.eco.plugin.xx.zgydsso.config.PluginSimpleConfig;
import com.eco.plugin.xx.zgydsso.utils.FRUtils;
import com.eco.plugin.xx.zgydsso.utils.Utils;
import com.fr.decision.fun.impl.AbstractGlobalRequestFilterProvider;
import com.fr.plugin.context.PluginContexts;
import com.fr.record.analyzer.EnableMetrics;
import com.fr.stable.fun.Authorize;
import com.ultrapower.casp.client.LoginUtil;
import com.ultrapower.casp.client.config.CaspClientConfig;
import com.ultrapower.casp.common.datatran.data.ticket.TransferTicket;
import com.ultrapower.casp.common.datatran.data.user.UserInfo;

import javax.servlet.FilterChain;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import javax.servlet.http.HttpSession;

@EnableMetrics
@Authorize(callSignKey = "com.eco.plugin.xx.zgydsso")
public class SSOFilter extends AbstractGlobalRequestFilterProvider {
    @Override
    public String filterName() {
        return "zgydssoFilter";
    }

    @Override
    public String[] urlPatterns() {
        return new String[]{"/*"};
    }

    @Override
    public void doFilter(HttpServletRequest req, HttpServletResponse res, FilterChain chain ){

        if(PluginContexts.currentContext().isAvailable()){
            //code

            //是否放行
            boolean release = isRelease(req);

            if(release){
                release(req,res,chain);
                return;
            }

            PluginSimpleConfig psc = PluginSimpleConfig.getInstance();

            LoginUtil loginUtil = LoginUtil.getInstance();
            loginUtil.initCustom(psc.getConfigurl(),psc.getConfigurlxml());
//            loginUtil.init(PluginSimpleConfig.getInstance().getConfigurl());
            CaspClientConfig caspClientConfig = CaspClientConfig.getInstance();
            FRUtils.FRLogInfo("appcode:"+caspClientConfig.getAppCode()+";appkey:"+caspClientConfig.getAppKey());
            boolean hasTicket = loginUtil.checkTicket(req);
            FRUtils.FRLogInfo("url:"+FRUtils.getAllUrl(req)+";hasTicket"+hasTicket);

            if(!hasTicket){
                loginUtil.redirectToServer(req,res);
                return ;
            }

            String ticket = loginUtil.getTicket(req);
            FRUtils.FRLogInfo("ticket:"+ticket);

            TransferTicket transferTicket = loginUtil.analysTicket(ticket);
            FRUtils.FRLogInfo("transferTicket is null :"+(transferTicket == null));

            FRUtils.FRLogInfo("transferTicket:"+transferTicket.toString());
            UserInfo user = loginUtil.qryUserByTicket(transferTicket);
            FRUtils.FRLogInfo("user:"+user.toString());

            String username = user.getAccountID();
            FRUtils.FRLogInfo("username:"+username);

            String url = Utils.getRedirectUrl(req,"iamcaspticket");

            //登出用
            HttpSession session = req.getSession(true);
            session.setAttribute("ticket",ticket);
            //登录
            FRUtils.login(req,res,username,url);
        }

        release(req,res,chain);
    }

	 private boolean isRelease(HttpServletRequest req) {
        String url = FRUtils.getAllUrl(req);
        String reft = req.getParameter("ref_t");

        boolean isLogin = FRUtils.isLogin(req);
        boolean isRemote = url.contains("remote");
        boolean isLoginPage = url.contains("login")||url.contains("decision/file")||url.contains("decision/resource")||url.contains("decision/system")||url.contains("query/ip");
        boolean isViewlt = url.contains("viewlet") || "design".equals(reft) || url.contains("view/report") || url.contains("view/form");
        boolean isValidate = url.contains("validateToken") || url.contains("getUserInfo") ||url.contains("/toOther");
        return isLogin || isLoginPage || isRemote || isValidate;
//        return isLogin || isRemote || isLoginPage || isViewlt;
    }

    //放行拦截器
    private void release(HttpServletRequest req, HttpServletResponse res, FilterChain chain) {
        try{
            chain.doFilter(req,res);
        }catch (Exception e){
            FRUtils.FRLogInfo("拦截失败");
        }
    }
}

