package com.eco.plugin.xx.zgydsso.utils;

import com.fr.decision.authority.base.constant.type.authority.AuthorityType;
import com.fr.decision.authority.data.Authority;
import com.fr.decision.webservice.impl.privilege.PrivilegeType;
import com.fr.decision.webservice.impl.privilege.RoleTypePrivilegeProcessFactory;
import com.fr.stable.query.QueryFactory;

import java.util.HashSet;
import java.util.List;
import java.util.Set;

/**
 * 权限工具类
 */
public class AuthorityUtils {

    /**
     * 根据角色id获取目录权限
     * @param roleid
     * @return
     */
    public static List<Authority> getAuthorityByRole(String roleid) throws Exception {
        PrivilegeType var5 = RoleTypePrivilegeProcessFactory.getPrivilegeType("entry");
        Set<Integer> privilegeTypes = new HashSet<Integer>();
        privilegeTypes.add(1);
        privilegeTypes.add(3);
        Set<AuthorityType> authorityType = AuthorityType.fromInteger(privilegeTypes);

        List<Authority> authorityList= var5.findByCustomRole(roleid, true, QueryFactory.create(), (AuthorityType[])authorityType.toArray(new AuthorityType[0]));

        return authorityList;
    }
}
