package com.eco.plugin.xx.zgydsso.utils;

import java.io.File;
import java.io.FileFilter;
import java.util.Arrays;
import java.util.Comparator;

/**
 * 文件处理类
 */
public class FileUtils {

    /**
     * 根据过滤器获取文件夹下所有文件，并按排序规则排序
     * @param folderPath
     * @param filter
     * @param c
     * @return
     */
    public static File[] getFileInFolderAndSort(String folderPath,FileFilter filter,Comparator c){
        File folder = new File(folderPath);

        //如果传入的路径是文件路径，那么直接返回
        if(folder.isFile()){
            return new File[]{folder};
        }

        //如果过滤器为空，则返回全部文件,不为空进行筛选
        File[] result =filter == null ? folder.listFiles() : folder.listFiles(filter);

        if(c != null){
            Arrays.sort(result,c);
        }

        return result;
    }


}
